'use strict'
const path = require('path')
const defaultSettings = require('./src/settings.js')

function resolve(dir) {
  return path.join(__dirname, dir)
}

const name = defaultSettings.title || 'ChargEco' // page title

// If your port is set to 80,
// use administrator privileges to execute the command line.
// For example, Mac: sudo npm run
// You can change the port by the following method:
// port = 9527 npm run dev OR npm run dev --port = 9527
const port = process.env.port || process.env.npm_config_port || 9527 // dev port

// All configuration item explanations can be find in https://cli.vuejs.org/config/
module.exports = {
  /**
   * You will need to set publicPath if you plan to deploy your site under a sub path,
   * for example GitHub Pages. If you plan to deploy your site to https://foo.github.io/bar/,
   * then publicPath should be set to "/bar/".
   * In most cases please use '/' !!!
   * Detail: https://cli.vuejs.org/config/#publicpath
   */
  publicPath: process.env.ENV === 'development' ? '/csms' : '',
  outputDir: 'dist',
  assetsDir: 'static',
  lintOnSave: process.env.NODE_ENV === 'development',
  productionSourceMap: false,
  devServer: {
    port: port,
    open: true,
    overlay: {
      warnings: false,
      errors: true
    },
  },
  configureWebpack: {
    // provide the app's title in webpack's name field, so that
    // it can be accessed in index.html to inject the correct title.
    name: name,
    resolve: {
      alias: {
        '@': resolve('src')
      }
    },
    externals: {
      'google': 'google'
    }
  },
  configureWebpack: config=> {
    if (process.env.NODE_ENV === 'production') {
      config.optimization.minimizer[0].options.terserOptions.compress.warnings = false
      config.optimization.minimizer[0].options.terserOptions.compress.drop_console = true
      config.optimization.minimizer[0].options.terserOptions.compress.drop_debugger = true
      config.optimization.minimizer[0].options.terserOptions.compress.pure_funcs = ['__f__','console.log','console.error']
    }
  },
  chainWebpack(config) {
    // it can improve the speed of the first screen, it is recommended to turn on preload
    // it can improve the speed of the first screen, it is recommended to turn on preload
    config.plugin('preload').tap(() => [
      {
        rel: 'preload',
        // to ignore runtime.js
        // https://github.com/vuejs/vue-cli/blob/dev/packages/@vue/cli-service/lib/config/app.js#L171
        fileBlacklist: [/\.map$/, /hot-update\.js$/, /runtime\..*\.js$/],
        include: 'initial'
      }
    ])

    // when there are many pages, it will cause too many meaningless requests
    config.plugins.delete('prefetch')

    // set svg-sprite-loader
    config.module
      .rule('svg')
      .exclude.add(resolve('src/icons'))
      .end()
    config.module
      .rule('icons')
      .test(/\.svg$/)
      .include.add(resolve('src/icons'))
      .end()
      .use('svg-sprite-loader')
      .loader('svg-sprite-loader')
      .options({
        symbolId: 'icon-[name]'
      })
      .end()

    config
      .when(process.env.NODE_ENV !== 'development',
        config => {
          config
            .plugin('ScriptExtHtmlWebpackPlugin')
            .after('html')
            .use('script-ext-html-webpack-plugin', [{
            // `runtime` must same as runtimeChunk name. default is `runtime`
              inline: /runtime\..*\.js$/
            }])
            .end()
          config
            .optimization.splitChunks({
              chunks: 'all',
              minSize: 20000,
              maxInitialRequests: Infinity,
              cacheGroups: {
                libs: {
                  name: 'chunk-libs',
                  test: /[\\/]node_modules[\\/]/,
                  priority: 10,
                  chunks: 'initial' // only package third parties that are initially dependent
                },
                elementUI: {
                  name: 'chunk-theme', // split elementUI into a single package
                  priority: 20, // the weight needs to be larger than libs and app or it will be packaged into libs or app
                  test: /[\\/]node_modules[\\/]_?element-ui(.*)/ // in order to adapt to cnpm
                },
                vue: {
                  name: 'chunk-vue',
                  test: /[\\/]node_modules[\\/](vue|vuex|vue-router|veu-loader|axios|screenfull|qrcodejs2)/,
                  priority: 30
                },
                echarts: {
                  name: 'chunk-echarts',// split echarts libs
                  test: /[\\/]node_modules[\\/](echarts)/,
                  priority: 35
                },
                googlemaps: {
                  name: 'chunk-googlemaps',// split others libs
                  test: /[\\/]node_modules[\\/](clipboardy|core-js|js-base64|js-cookie|nprogress|@googlemaps)/,
                  priority: 39
                },
                router: {
                  name: 'chunk-router',
                  test: /[\\/]src[\\/]views[\\/](charging|transaction|user|driver)/,
                  priority: 40
                },
                commons: {
                  name: 'chunk-commons',
                  test: /[\\/]src[\\/]views[\\/](site|charge|ocpp|login)/, // can customize your rules
                  priority: 41
                },
                vbea: {
                  name: 'chunk-vbea',
                  test: /[\\/]src[\\/]views[\\/](limit|feedback|financial|provider)/,
                  priority: 42
                },
                index: {
                  name: 'chunk-index',
                  test: /[\\/]src[\\/]views[\\/](dashboard)/,
                  priority: 44
                },
                assets: {
                  name: 'chunk-assets',
                  test: /[\\/]src[\\/](assets|icons)/,
                  priority: 50
                },
                utils: {
                  name: 'chunk-utils',
                  test: /[\\/]src[\\/](utils|layout|store|router|components|http)/,
                  priority: 51
                }
              }
            })
          // https:// webpack.js.org/configuration/optimization/#optimizationruntimechunk
          config.optimization.runtimeChunk('single')
        }
      )
  }
}
